#include <iostream>
#include <limits>

using namespace std;

int main()
{
    int N;
    cin>>N;
    int A[N];
    for(int i = 0; i < N; i++)
    {
        cin>>A[i];
    }
    int Q;
    cin>>Q;
    int l[Q];
    int r[Q];
    bool Resenja[Q];
    for(int i = 0; i < Q; i++)
    {
        cin>>l[i]>>r[i];
        int X=0;
        int Prosli = INT_MAX;
        bool flag = false;
        bool Reseno = false;

        //Provera jel vec reseno
        for(int j = 0; j < i && !Reseno; j++)
        {
            if(l[i]<=l[j] && r[i]>=r[j] && Resenja[j]==false)
            {
                X=2;
                Reseno=true;
            }
            if(l[i]>=l[j] && r[i]<=r[j] && Resenja[j] == true)
            {
                Reseno=true;
                X=0;
            }
        }

        //Resavanje
        for(int j = l[i]; j<r[i] && !Reseno; j++)
        {
            if(flag)
            {
                if(A[j]<A[j-2])
                {
                    X++;
                    flag = false;
                    j=r[i];
                    Reseno=true;
                }
            }
            if(A[j]<A[j-1])
            {
                X++;
                if(A[j-1]-A[j]>Prosli)
                {
                    flag = true;
                }
            }
            Prosli = A[j] - A[j-1];
            if(X>=2)
            {
                j=r[i];
                Reseno=true;
            }

        }

        Resenja[i]=X<2;
    }
    for(int i = 0; i < Q; i++)
    {
        if(Resenja[i])
        {
            cout<<"DA"<<endl;
        }
        else
        {
            cout<<"NE"<<endl;
        }
    }
    return 0;
}